/*
 * Copyright (c) 2024 Jonas 'Sortie' Termansen.
 *
 * Permission to use, copy, modify, and distribute this software for any
 * purpose with or without fee is hereby granted, provided that the above
 * copyright notice and this permission notice appear in all copies.
 *
 * THE SOFTWARE IS PROVIDED "AS IS" AND THE AUTHOR DISCLAIMS ALL WARRANTIES
 * WITH REGARD TO THIS SOFTWARE INCLUDING ALL IMPLIED WARRANTIES OF
 * MERCHANTABILITY AND FITNESS. IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR
 * ANY SPECIAL, DIRECT, INDIRECT, OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES
 * WHATSOEVER RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN
 * ACTION OF CONTRACT, NEGLIGENCE OR OTHER TORTIOUS ACTION, ARISING OUT OF
 * OR IN CONNECTION WITH THE USE OR PERFORMANCE OF THIS SOFTWARE.
 *
 * string/memmem.c
 * Locate a subsequence.
 */

#include <string.h>

// TODO: Remember the fast algorithm and implemented it here and in strstr.
void* memmem(const void* haystack, size_t haystack_size,
             const void* needle, size_t needle_size)
{
	if ( !needle_size )
		return (void*) haystack;
	if ( haystack_size < needle_size )
		return NULL;
	for ( size_t i = 0; i < haystack_size - needle_size; i++ )
	{
		for ( size_t n = 0; n < needle_size; n++ )
		{
			if ( ((char*) haystack)[i + n] != ((char*) needle)[n] )
				break;
			if ( n + 1 == needle_size )
				return (char*) haystack + i;
		}
	}
	return NULL;
}
